from functools import partial

from ImageFunctions import *
from multiprocessing import Pool
import sys
import glob
import cv2 as cv
import os
import numpy as np

# meta data global default variables
DEFAULT_TILE_WIDTH = 1000
DEFAULT_TILE_HEIGHT = 1000
DEFAULT_IMG_WIDTH = 1920
DEFAULT_IMG_HEIGHT = 1080
DEFAULT_CAMERA_HEIGHT = 200
DEFAULT_SUN_YAW = -137.008804
DEFAULT_SUN_PITCH = -30.0
DEFAULT_SUN_ROLL = 170.730103
UNREAL_X_OFFSET = 40500
UNREAL_Y_OFFSET = 40500
UNREAL_UNITS_PER_PIXEL = 5
UNREAL_X_Y_AXIS_SWITCH = True

N_POOL = 24  # Number of parallel threads upon which to run reprojection script

fullmap_images = {'training': [],
                  'testing': [],
                  'validation': []}

def aerial_fn(map_mode, meta):
    filename = meta[0].split('/')[-1]
    location_id = filename.split('_info')[0]

    img_meta = load_tile_meta(meta[0], map_mode)

    aerial_height = 1000
    aerial_width = 1000

    tile_info = {'left': img_meta['x'],
                 'top': img_meta['y']}

    fullmap_tile_id, fullmap_coords = extract_aerial_tile(tile_info, map_mode)

    try:
        master_img = fullmap_images[map_mode][fullmap_tile_id]
    except:
        print('error for image: '+location_id)
    print(str(fullmap_tile_id))
    aerial_img = master_img[int(np.round(fullmap_coords['y'], 0)):int(np.round(fullmap_coords['y'], 0)) + aerial_height,
                 int(np.round(fullmap_coords['x'], 0)):int(np.round(fullmap_coords['x'], 0)) + aerial_width]
    #aerial_img = master_img[int(np.round(fullmap_coords['y']+aerial_height/2, 0)):int(np.round(fullmap_coords['y']+aerial_height/2, 0)) + aerial_height,
    #            int(np.round(fullmap_coords['x']+aerial_width/2, 0)):int(np.round(fullmap_coords['x']+aerial_width/2, 0)) + aerial_width]

    aerial_img_filename = os.path.join(str(output_path), 'aerial_'+str(location_id) + '.png')
    cv.imwrite(aerial_img_filename, aerial_img)  # grayscale
    print('aerial_%08i.png' % int(location_id))


def extract_aerial_tile(tile_info, map_mode):
    x, y = tile_info['left'], tile_info['top']
    tile_x = int(np.divide(float(x), 5000.125)) #necessary for left coord of 40000
    tile_y = int(np.divide(float(y), 5000.125))
    fullmap_coords = {'x': int(x-(tile_x * 5000)), 'y': int(y-(tile_y * 5000))} # using floor to avoid edge case of 0.6->0.8 rounding to unrepresented pixel
    # if tile_y == 8:
    #     tile_y = 7
    #     fullmap_coords['y'] += 5000
    # if tile_x == 8:
    #     tile_x = 7
    #     fullmap_coords['x'] += 5000
    if map_mode == 'training':
        fullmap_tile_id = (tile_x * 8) + tile_y
    elif map_mode == 'testing':
        fullmap_tile_id = (tile_x * 4) + tile_y
    elif map_mode == 'validation':
        fullmap_tile_id = (tile_x * 4) + tile_y
    else:
        print('ERROR: invalid map_mode! (training, validation, testing)')

    return fullmap_tile_id, fullmap_coords


def load_tile_meta(tile_meta_filepath, map_mode='training', quiet_operation=True):
    """ tile_meta_filename  - filename of tile meta text file
        directory - directory of tile meta text files
            Version0.1:
                Tile meta data storage convention is:
                	x_y_z_roll_pitch_yaw
                Where _ is the variable seperator
    """
    f = open(str(tile_meta_filepath), 'rU')
    meta_contents = f.read()
    f.close()
    # example contents:
    # XYZ_-4951.0_765.0_1278.324219_RPY_0.0_-15.0_0.0_SunRPY_170.730072_-31.686462_-137.008774
    meta_contents = meta_contents.split('_')
    tile_meta = {'x': float(meta_contents[1]),
                 'y': float(meta_contents[2]),
                 'z': float(meta_contents[3]),
                 'roll': float(meta_contents[5]),
                 'pitch': float(meta_contents[6]),
                 'yaw': float(meta_contents[7]),
                 'sun_roll': float(meta_contents[9]),
                 'sun_pitch': float(meta_contents[10]),
                 'sun_yaw': float(meta_contents[11]),
    }
    try:
        tile_meta['camera_height'] = float(meta_contents[13])
    except IndexError:
        if quiet_operation == False:
            print('WARNING: Camera height not found in meta-data file. \nDefaulting to values: CamHeight =' + str(DEFAULT_CAMERA_HEIGHT))
        tile_meta['camera_height'] = float(DEFAULT_CAMERA_HEIGHT)
    try:
        tile_meta['width'] = int(meta_contents[15])
        tile_meta['height'] = int(meta_contents[16])
    except IndexError:
        if quiet_operation == False:
            print('WARNING: Tile width and height not found in meta-data file. \nDefaulting to values: width=' + str(DEFAULT_TILE_WIDTH) + ' height=' + str(DEFAULT_TILE_HEIGHT))
        tile_meta['width'] = int(DEFAULT_IMG_WIDTH)
        tile_meta['height'] = int(DEFAULT_IMG_HEIGHT)
        if quiet_operation == False:
            print('ALERT: Converting meta-data generated by Unreal Engine to pixel-based meta-data')
    return convert_unreal_meta_to_tile_meta(tile_meta, map_mode)


def convert_unreal_meta_to_tile_meta(tile_meta, map_mode='training'):
    if map_mode == 'training':
        map_px_top = 40500
        map_px_left = -40500
        num_width_tiles = 8
        num_height_tiles = 8
        map_tile_px_width = 5000
        map_tile_px_height = 5000
        units_per_pixel = 5
        switch_x_y = True
    elif map_mode == 'validation':
        map_px_top = 30000
        map_px_left = 10000
        num_width_tiles = 4
        num_height_tiles = 4
        map_tile_px_width = 5000
        map_tile_px_height = 5000
        units_per_pixel = 5
        switch_x_y = True
    elif map_mode == 'testing':
        map_px_top = -10000
        map_px_left = -30000
        num_width_tiles = 4
        num_height_tiles = 4
        map_tile_px_width = 5000
        map_tile_px_height = 5000
        units_per_pixel = 5
        switch_x_y = True
    else:
        print('Error: invalid map meta provided (train, validate, test)')

    #if UNREAL_X_Y_AXIS_SWITCH is True:
    if switch_x_y is True:
        tile_meta['x'], tile_meta['y'] = tile_meta['y'], tile_meta['x']
    tile_meta['x'] = np.round(tile_meta['x'] / float(UNREAL_UNITS_PER_PIXEL), 1)
    tile_meta['y'] = np.round(tile_meta['y'] / float(UNREAL_UNITS_PER_PIXEL), 1)
    tile_meta['y'] = int((-tile_meta['y'] +  map_px_top) - ((DEFAULT_TILE_HEIGHT/2)+1))
    tile_meta['x'] = int((tile_meta['x'] - map_px_left) - ((DEFAULT_TILE_WIDTH/2)+1))
    #tile_meta['y'] = int((-tile_meta['y'] + map_px_top) - 1)
    #tile_meta['x'] = int((tile_meta['x'] - map_px_left) - 1)
    return tile_meta

def join(iterator, seperator):
    it = map(str, iterator)
    seperator = str(seperator)
    string = next(it, '')
    for s in it:
        string += seperator + s
    return string

if __name__ == '__main__':
    game_path = str(sys.argv[1])  # Location of MoonBench 'game' folder
    maps_path = str(sys.argv[2])  # Location of maps folders (trainingMap, validationMap and testingMap)
    save_path = os.path.join(os.path.join(game_path, 'MyProject'), 'Saved')

    output_dir = os.path.join(save_path, 'Aerial')
    if not os.path.isdir(output_dir):
        os.mkdir(output_dir)

    for area in ['training', 'validation', 'testing']:
        meta_path = os.path.join(os.path.join(save_path, 'Screenshots'), 'coordinates_' + area)
        output_path = os.path.join(output_dir, 'images_' + area)
        if not os.path.isdir(output_path):
            os.mkdir(output_path)
        map_path = os.path.join(maps_path, area+'Map')
        if area is 'training':
            map_path += 's'

        all_meta = sorted(glob.glob(os.path.join(meta_path, '*.txt')))            # meta data files

        all_maps = sorted(glob.glob(os.path.join(map_path, 'splitImages_*')))
        resort_maps = all_maps.copy()
        for i in range(len(all_maps)):
            filesplit = all_maps[i].split(os.sep)
            tile_id = filesplit[-1].split('_')[-1].split('.')[0]
            filesplit[-1] = 'splitImages_%02i.png' % int(tile_id)
            resort_maps[i] = join(filesplit, os.sep)
        sort_key = sorted(range(len(resort_maps)), key=lambda k: resort_maps[k])

        if len(all_meta) > 0:
            for i in range(len(all_maps)):
                fullmap_images[area].append(cv.imread(all_maps[sort_key[i]], 0))
            num_loc = len(all_meta)
            rov_locs = np.array_split(all_meta, num_loc)

            # parallel
            #func = partial(aerial_fn, area)
            #p = Pool(N_POOL)
            #p.map(func, rov_locs)

            # serial
            for i in range(num_loc):
                aerial_fn(area, rov_locs[i])
